Subject: Re: bug#45518: Ctrl-G Fails to Interrupt Hung Tramp Remote-Compile in Emacs 27.1

From: Michael Albinus <[email-masked]>
Date: Thu, 31 Dec 2020 09:42:15 +0100

Duncan Greatwood <[email-masked]> writes:

> Hi Michael,

Hi Duncan,

> [DG] I note in passing that in my emacs 27.1 build, I already have
> Tramp 2.5.0 installed as per:
>     M-x list-packages
>     ...
>       tramp              2.5.0         available

Well, this doe NOT mean it is installed already. It is available in the
package archive.

> Nonetheless, I downloaded from this page:
> https://elpa.gnu.org/packages/tramp.html
>     tramp-2.5.0.tar, 2020-Dec-29, 1.61 MiB
> I expanded the tar to a local directory, call it ~/.../tramp-2.5.0
>
> I then added the following to my .emacs file:
>     (add-to-list 'load-path (expand-file-name "~/.../tramp-2.5.0"))
>     (require 'tramp)

That's one way to do it. The more natural way is "M-x package-install
RET tramp". Or, in the *Packages* buffer, mark the package with "i", and
install it via "x".

> Happy news - with this addition to .emacs, pressing ctrl-g three times
> once again interrupts the hung Tramp window, and .emacs as a whole
> does not crash.
>
> I tried adding and removing the .emacs lines several times, and the
> matter produces perfectly: ctrl-gx3 always works when the .emacs lines
> are present, and never works when they are not in emacs 27.1.

Great!

> The only slight wrinkle I noticed with this newest version of tramp
> (vs. emacs 26.2 tramp) is that, after pressing ctrl-gx3, it feels I
> have to click around to another window and back in order to see the
> error output from the compile appear in the tramp compile window,
> wheres in emacs 26.2 the error output would start appearing in the
> tramp compile window as soon as ctrl-gx3 was pressed. No terrible
> hardship but JFYI.
>
> Is there anything I can do that would help diagnose / pinpoint or
> whatever? Either with the ctrl-gx3 matter, or indeed with the
> underlying hang in the tramp compile window which requires the use of
> ctrl-gx3.

I will try to reproduce it locally. Since I don't know where to start
with debugging, I cant give you instructions for this yet.

> Best regards,
> Duncan

Best regards, Michael.